#!/usr/bin/python

# Copyright 2013 William Witteman                                               
 
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

"""
Take the output of the clinicaltrialsregister.eu (a big text file) and
spit out a CSV file with basic, ID, trialname, description info.
"""

import csv, sys, re

filelist = sys.argv[1:]

#debug print(filelist)

if len(filelist) == 0:
  print("There's nothing to do")
else:
  with open("clinicaltrials-eu.csv","wb") as csvfile:
    trialwriter = csv.writer(csvfile)
    #debug trialwriter.writerow(["sep=,"])
    trialwriter.writerow(["EudraCT Number","Trial Title"])
    summary = re.compile("^Summary")
    eudra = re.compile("^EudraCT Number:")
    title = re.compile("^A\.3 Full title of the trial:")
    for x in filelist:
      #debug print(x)
      fulltext = open(x,"r").readlines()
      #debug print(fulltext)
      onerow = ["",""]
      for line in fulltext:
        if summary.match(line):
          onerow = ["",""]
        elif (eudra.match(line)):
          onerow[0] = line.strip()[16:]
        elif (title.match(line)):
          onerow[1] = line.strip()[29:]
          trialwriter.writerow(onerow)
          onerow = ["",""]
        else:
          pass


